// acf4swfobject.js
// Copyright (c) 2008 IBM Corporation.

function inherit(subClass, superClass) {
//	var s = "";
	for (var prop in superClass.prototype) {
		subClass.prototype[prop] = superClass.prototype[prop];
//		s += "copying prototype[" + prop + "] = " + superClass.prototype[prop] + "\n";
	}
//	alert(s);
}

function isEmpty(s){
	if(s == undefined || s == "" || s == null){
		return true;
	}
	return false;
}

    
// ==========================================================================
// URL object
// ==========================================================================
function URL(str){
	var urlRegexp = /^((\w+):\/\/)?((\w+):?(\w+)?@)?([^\/\?:]+):?(\d+)?(\/?[^\?#]+)?\??([^#]+)?#?(\w*)/ ;

	
	// --------------------------------
	// Parse a URL
	// --------------------------------
	this.parse = function(s){
		this.strurl = str;
		this.tokens = urlRegexp.exec(s);
		
		// somehow, the filename of a relative path is interpreted as a hostname
		// below is a workaround to swap the tokens to the correct positions
		if(isEmpty(this.tokens[1]) 
			&& (!isEmpty(this.tokens[6]))
			&& isEmpty(this.tokens[8])){
			this.tokens[8] = this.tokens[6];
			this.tokens[6] = undefined;
		}
	}

	this.getProtocol = function(){
		if(isEmpty(this.tokens[2])){
			return undefined;
		}
		return this.tokens[2];
	}

	this.getUser = function(){
		if(isEmpty(this.tokens[4])){
			return undefined;
		}
		return this.tokens[4];
	}

	this.getPassword = function(){
		if(isEmpty(this.tokens[5])){
			return undefined;
		}
		return this.tokens[5];
	}

	this.getHost = function(){
		if(isEmpty(this.tokens[6])){
			return undefined;
		}
		return this.tokens[6];
	}

	this.getPort = function(){
		if(isEmpty(this.tokens[7])){
			return undefined;
		}
		return this.tokens[7];
	}

	this.getPath = function(){
		if(isEmpty(this.tokens[8])){
			return undefined;
		}
		return this.tokens[8];
	}

	this.getQuery = function(){
		if(isEmpty(this.tokens[9])){
			return undefined;
		}
		return this.tokens[9];
	}
	this.setQuery = function(s){
		this.tokens[9] = s;
	}

	this.getFragment = function(){
		if(isEmpty(this.tokens[10])){
			return undefined;
		}
		return this.tokens[10];
	}
	this.setFragment = function(s){
		this.tokens[10] = s;
	}
	
	this.dump = function(){
		var parsed = "host: " + this.getHost() + "\n";
		parsed += "port: " + this.getPort() + "\n";
		parsed += "path: " + this.getPath() + "\n";
		parsed += "query: " + this.getQuery() + "\n";
		parsed += "fragment : " + this.getFragment();
		
		try{
			var s="";
			for(var i=0 ; i<this.tokens.length ; i++){
				s += "token[" + i + "] = " + this.tokens[i] + "\n";
			}
		}catch(ex){ alert(ex  + ": " + params); }
		alert(s);
	}
	
	this.toString = function(){
		var s = "";
		if(this.getProtocol()!= undefined && this.getHost() != undefined){
			s += this.getProtocol();
			s += "://";
			
			if(this.getUser() != undefined){
				s += this.getUser();
				s += ":";
			}
			if(this.getPassword() != undefined){
				s += this.getPassword();
				s += "@";
			}
			s += this.getHost();
			
			if(this.getPort() != undefined){
				s += ":";
				s += this.getPort();
			}
		}
		if(this.getPath() != undefined){
			s += this.getPath();
		}
		
		if(this.getQuery() != undefined){
			s += "?";
			s += this.getQuery();
		}
		if(this.getFragment() != undefined && this.getFragment() != ""){
			s += "#";
			s += this.getFragment();
		}
		return s;
	}
	
	// initializing the object with the argument to the URL constructor
	this.parse(str);

}; // end of URL()



// ==========================================================================
// ACF4SWFObject
//	Main object that overrides method of SWFObject
// ==========================================================================
function ACF4SWFObject(){

	var regexpScript       = /(.*)(javascript:)(.*)/i ;
	var regexpScriptDetail = /(.*)(javascript:)([^&=]*)(.*)/i ;

// --------------------------------------------------------------------------
// dump the properties of "swfobject". This function is for debugging.
// --------------------------------------------------------------------------
this.objToString = function(obj){
	var s = "{";
	for(x in obj){
		s += x + ":'" + obj[x];
		s += "', ";
	}
	s += "}";
	return s;
}
this.dumpSWFObject = function(){
	alert(this.objToString(swfobject));
/*	var s = "";
	for(x in swfobject){
		s += x;
		s += "\n";
	}
	alert(s);
*/
};


// --------------------------------------------------------------------------
// Sanitization Mode Setting
//    acf4swfobject.setMode(mode) 
// mode = this.MODE_REMOVE_ALL : when removing entire URL
// mode = this.MODE_REMOVE_ONLY_PARAMS : when removing only injected script
// --------------------------------------------------------------------------
this.MODE_REMOVE_ALL		= 1;
this.MODE_REMOVE_ONLY_PARAM = 2;

this.mode = this.MODE_REMOVE_ONLY_PARAM; // default mode

this.setMode = function(m){
	this.mode = m;
};

// --------------------------------------------------------------------------
// Parse Parameters (Query String and FlashVars in the "a=b&c=d" style
// --------------------------------------------------------------------------
function parseParams(query){
	if(query == undefined) { return null; };
	var params = [];
	var searchIndex = 0;
	var index = 0;
	var name, value;
	var i;
	for(i=0 ; ; i++){
//		alert("parseParams(" + query + "): searchIndex=" + searchIndex);
		index = query.indexOf("=", searchIndex);
		if(index >= searchIndex){
			name = query.substring(searchIndex, index);
			searchIndex = index + 1;
			index = query.indexOf("&", searchIndex);
			if(index >= searchIndex){
				value = query.substring(searchIndex, index);
				searchIndex = index + 1;
				params[i] = { "name": name, "value": value };
			}else{ // end of query
				value = query.substring(searchIndex);
				params[i] = { "name": name, "value": value };
				break;
			}
		}else{
			// no "=" was found
			params[i] = { "name": query.substring(searchIndex), "value": "" };
			break;
		}
	}
	
//	var s="";
//	for(i=0 ; i<params.length ; i++){
//		s += params[i].name + " = " + params[i].value + "\n";
//	}
//	alert("Parsed : " + s);
	
	return params;
}

// --------------------------------------------------------------------------
// Canonicalize URL encoding and XML Entity references into plain text
// --------------------------------------------------------------------------
// Character Entity Reference
//	c.f. http://www.w3.org/TR/REC-html40/sgml/entities.html
var charRefs = { nbsp: "\xA0", quot: "\"", amp:"&", lt:"<", gt:">" };

this.canonicalize = function(s){
	var sout = "";
	var searchIndex = 0;
	var start = 0;
	var end = 0;
	var nextSearchIndex = 0;
	var name;
//	alert("canonicalize input: " + s);
//	s = unescape(s);

	
	for(var i=0 ; i<s.length ; i++){
		if(s.charAt(i) == "&"){
//			console.log("'&' was found at: " + i);
			var j = i+1;
			while(s.charAt(j) != "&" && s.charAt(j) != ";" && j < s.length){
				j++;
			}
			if(j > i){
				var name = s.substring(i+1, j);
// alert("after & : s[" + (i+1) + ","+ j + "] = " + name);
				i = j;
				if(s.charAt(j) != ";"){
					i--; 	// skip only ";". 
							// Other chars should be processed in next iterations
				}
			}else{
// alert("after & : no matching ';' or '&' was found");
				sout += s.charAt(i);
				continue;
			}
			var val = charRefs[name];
				if(val != undefined && val != null){
					sout += val;
//					console.log("... named reference found for = " + name + ", val=" + val);
				}else if(name.charAt(0) == "#"){
					if(name.charAt(1) == "x" || name.charAt(1) == "X"){
						// hexadecimal
						var charval = parseInt(name.substring(2), 16);
//						alert("... hexadecimal for = " + name + ", val=" + charval + " \"" +  String.fromCharCode(charval) + "\"");
						sout += String.fromCharCode(charval);
					}else{
						var charval = parseInt(name.substring(1), 10);
//						alert("... end > start: decimal for = " + name + ", val=" + charval + " \"" +  String.fromCharCode(charval) + "\"");
						sout += String.fromCharCode(charval);
					}
				}else{
					sout += "&" + name;
				}

		}else{
			sout += s.charAt(i);
		}
	}

	sout = sout.replace(/[\s\n\r\t\v]+/g, "");
//	alert("canonnicalize output: " + sout);
	return sout;
}
var canonicalize = this.canonicalize;

// --------------------------------------------------------------------------
// Sanitize Parameters
// --------------------------------------------------------------------------
var doSanitizeParams = function(query){
//	alert("doSanitizeParams() query=" + query);
	
	if(isEmpty(query)){
		return query;
	}
	
	// parse as query string
	var params = parseParams(query);
	
//	alert("doSanitizeParams() query=" + query);

/*
	var tmps = "sanitizeParams : " + query + "\n";
	for(var i=0 ; i<params.length ; i++){
		tmps += "params[" + i + "] " + params[i].name + " = " + params[i].value + "\n";
	}
	console.log(tmps);
*/
	
	var isSanitized = false;
	for(var i=0 ; i<params.length ; i++){
//		alert("params[" + i + "].value=" + params[i].value);
		var value = unescape(params[i].value); // canonicalize(params[i].value) ; 
		var isJS = regexpScript.exec(value);
//		alert("regexpScript.exec(" + value + ") = " + isJS);
		if(isJS != null){
			// injection was found...
			isSanitized = true;
			params[i].value = null;
//			alert("Sanitized: name = " + params[i].name);

			if(acf4swfobject.mode == acf4swfobject.MODE_REMOVE_ALL){
				return "";	// remove all
			}
		}
	}
	if(isSanitized){
		query = "";
		for(var i=0 ; i<params.length ; i++){
			query += params[i].name + "=";
			if(params[i].value != null){
				query += params[i].value;
			}
			if(i < params.length-1){
				query += "&";
			}
		}
//		alert("Sanitized: query = " + query);
	}
	return query;
	
};
// --------------------------------------------------------------------------
// Sanitize Parameters
//  this function calls doSanitizeParams AFTER canonicalizing the query string.
// --------------------------------------------------------------------------
var sanitizeParams = function(query){
	var c14nQuery;
	if(! isEmpty(query)){
		c14nQuery = canonicalize(query);
//		console.log("sanitizeParams: canonicalized query = " + c14nQuery);
	}
	var sanitizedQuery = doSanitizeParams(c14nQuery);
	
	// if nothing has been removed, return the original query
	if(sanitizedQuery == c14nQuery){
		return query;
	}else{
		return sanitizedQuery;
	}
}
this.sanitizeParams = sanitizeParams;

// --------------------------------------------------------------------------
// Sanitize URL
// --------------------------------------------------------------------------
var sanitizeURL = function(url){	
	// a malicious URL may include character entity references or numeric references
	// that includes "&". So we have to canonicalize them into text first.
	// otherwise, parsing as query string fails because of "&".
	
	if(isEmpty(url)){
		return url;
	}
	
	url = canonicalize(url);

	var parsedurl = new URL(url);
//	parsedurl.dump();
		
	// sanitize injection
	var query = parsedurl.getQuery();
	var newquery = doSanitizeParams(query);
	var newurl = null;
	if(newquery != query){
		if(acf4swfobject.mode == acf4swfobject.MODE_REMOVE_ONLY_PARAM){
			// remove only malicious part.
			parsedurl.setQuery(newquery);
			newurl = parsedurl.toString();
//			alert("partially sanitized: " + newurl);
			return newurl;
		}else{
//			alert("all removed");
			return "";
		}
	}
		
	return url;
}
this.sanitizeURL = sanitizeURL;

// --------------------------------------------------------------------------
// Sanitize Object Properties
//	This method sanitizes the injection in object properties:
//	{ a:"x", "b:"javascript:alert('xss')"} 
//	will be sanitized to:
//	{}	when mode = MODE_REMOVE_ALL
//	{ a:"x" } when mode = MODE_REMOVE_ONLY_PARAM
// --------------------------------------------------------------------------
var sanitizeObjProps = function(obj){
	for(p in obj){
		var v = canonicalize(obj[p]);
		
		if(acf4swfobject.mode == acf4swfobject.MODE_REMOVE_ALL){
			var tokens = regexpScriptDetail.exec(v);
			if(tokens != null){
				obj[p] = undefined;
			}
		}else{
			v = sanitizeParams(v);
			obj[p] = v;
		}
	}
	
//	var s = "";
//	for(p in obj){
//		s += "obj[" + p + "]=" + obj[p] + "\n";
//	}
//	alert(s);

	return obj;
}
this.sanitizeObjProps = sanitizeObjProps;

// --------------------------------------------------------------------------
// Initialize
//	Overrides methods of swfobject with to sanitize parameters
// --------------------------------------------------------------------------
this.initialize = function(){
	
  try{
//	alert("acf4swfobject.initialize() is called: " + swfobject.embedSWF);
	
	/*
	// -------------------------
	// swfobject.registerObject
	// -------------------------
	var bak_registerObject = swfobject.registerObject;
	swfobject.registerObject = function(flashId, playerVer, alternativeContent){
		alternativeContent = sanitizeURL(alternativeContent);
		return bak_registerObject(flashId, playerVer, alternativeContent);
	}
	*/
	
	// -------------------------
	// swfobject.embedSWF
	// -------------------------
	var bak_embedSWF = swfobject.embedSWF;
	swfobject.embedSWF = function(url, divid, width, height, ver, xiswfurl, flashvars, params, attributes){
		//alert("embedSWF=" + swfobject.embedSWF);
//		alert("swfobject id=" + divid + ": URL=" + url);

		//
		// Insert ACF logic here to check malicious URL and parameters
		// 

		// 1) sanitize SWF url
		var newurl = sanitizeURL(url);
		if(newurl != url){
//			alert("Injection Removed: \nOrg: " + url + "\nNew: " + newurl);
			url = newurl;
		}
		
		// 2) sanitize xiswfurl
		if(xiswfurl != undefined){
			var newxiswfurl = sanitizeURL(xiswfurl);
			if(newxiswfurl != xiswfurl){
//				alert("Injection Removed: \nOrg: " + xiswfurl + "\nNew: " + newxiswfurl);
				xiswfurl = newxiswfurl;
			}
		}

		// 3) sanitize flashvars
		if(flashvars != undefined){
			flashvars = sanitizeObjProps(flashvars);
		}
	
		// 4) params
		if(params != undefined){
			params = sanitizeObjProps(params);
		}

		// calling the original funciton
		bak_embedSWF(url, divid, width, height, ver, xiswfurl, flashvars, params, attributes);
	};// end of swfobject.embedSWF rewriting
	
	// -------------------------
	// swfobject.createSWF
	// -------------------------
	var bak_createSWF = swfobject.createSWF;
	swfobject.createSWF = function(attObj, parObj, replaceElemId){
		new_attObj = sanitizeObject(attObj);
		new_parObj = sanitizeObject(parObj);
		return bak_createSWF(new_attObj, new_parObj, replaceElemId);
	}

	// -------------------------
	// swfobject.registerObject
	// -------------------------
	var bak_registerObject = swfobject.registerObject;
	swfobject.registerObject = function(objectIdStr, swfVersionStr, xiSwfUrlStr){
		var newXiSwfUrlStr = sanitizeURL(xiSwfUrlStr);
		if(newXiSwfUrlStr != xiSwfUrlStr){
			xiSwfUrlStr = newXiSwfUrlStr
		}
		return bak_registerObject(objectIdStr, swfVersionStr, xiSwfUrlStr);
	}
  }catch(ex){
  }



// ==============================================
// for SWFObject 1.5
// ==============================================
try{
	// remember the original SWFObject (constructor function)
	var bak_SWFObject = SWFObject;

	// overrides SWFObject... the global SWFObject variable needs to be overridden
	SWFObject = function(swf, id, width, height, version, bgcolor, quality, xiRedirectUrl, redirectUrl, detectKey){
			
		// sanitize parameters
		swf = acf4swfobject.sanitizeURL(swf);
		xiRedirectUrl = acf4swfobject.sanitizeURL(xiRedirectUrl);
		redirectUrl = acf4swfobject.sanitizeURL(redirectUrl);
		
		// create an original SWFObject instance
		var bak_so = new bak_SWFObject(swf, id, width, height, version, bgcolor, quality, xiRedirectUrl, redirectUrl, detectKey);

		// inherit the prototype methods of the original SWFObject
		inherit(SWFObject, bak_SWFObject);
		
		SWFObject.prototype.useExpressInstall = function(xiurl){
			xiurl = acf4swfobject.sanitizeURL(xiurl);
			bak_so.useExpressInstall(xiurl);
		}		
		SWFObject.prototype.setAttribute = function(name, value){
			value = acf4swfobject.sanitizeParams(value);
			bak_so.setAttribute(name, value);
		};
		SWFObject.prototype.getAttribute = function(name){
			return bak_so.getAttribute(name);
		}
		
		SWFObject.prototype.addParam = function(name, value){
			value = acf4swfobject.sanitizeParams(value);
			bak_so.addParam(name, value);
		}
		SWFObject.prototype.getParams = function(){
			return bak_so.getParams();
		}
		
		SWFObject.prototype.addVariable = function(name, value){
			value = acf4swfobject.sanitizeParams(value);
			bak_so.addVariable(name, value);
		}
		SWFObject.prototype.getVariable = function(name){
			return bak_so.getVariable(name);
		}
		SWFObject.prototype.getVariablePairs = function(){
			return bak_so.getVariablePairs();
		}
		SWFObject.prototype.getVariablePairs = function(){
			return bak_so.getVariablePairs();
		}
		SWFObject.prototype.getSWFHTML = function(){
			return bak_so.getSWFHTML();
		}
		SWFObject.prototype.write = function(divid){
			bak_so.write(divid);
		};
	}; // end of overriding SWFObject for v1.5

}catch(ex){
	// You will get an exception if SWFObject is not defined. Ignore it.
	// alert(ex);
}

// ==============================================
// for UFO
// ==============================================
try{
	// remember the original UFO.create
	var bak_UFO_create = UFO.create;
	UFO.create = function(obj, id){
		var oldS = acf4swfobject.objToString(obj);
		var newObj = sanitizeObjProps(obj);
		var newS = acf4swfobject.objToString(newObj);
		//if(newS != oldS){
		//	alert("UFO.create: \nbefore: " + oldS + "\nafter :" + newS);
		//}
		return bak_UFO_create(obj, id);
	}
}catch(ex){
}
}; // end of ACF4SWFObject.initialize()
}; // end of ACF4SWFObject

acf4swfobject = new ACF4SWFObject();

//// set removal mode: choose either one
acf4swfobject.setMode(acf4swfobject.MODE_REMOVE_ALL);
// acf4swfobject.setMode(acf4swfobject.MODE_REMOVE_ONLY_PARAM);

acf4swfobject.initialize();
